function myHostMessageHandler(arg) {
/*
 * WebView2 (Chrome) bietet nur EINEN einsprung-punkt
 * d.H. ALLE unsere Hosts (CWebViewHost, CHostContactDetails, ...) muessen ueber ein uebergreifenden NamesSchema
 * verfuegen so das eine Messsage EINDEUTIG zugeordnet werden kann!
 */
	try {
/*
 * wir vermeiden aktuell das ermitteln der BPIInformation aus generischen Asn... methoden.
 * Begruendung: Aufwand!
 * wir muessten uns hier explizit fuer ALLE moeglichen channels subscriben.
 * wir muessten snapshot methoden fuer ALLE moeglichen channels implementieren ...
 *
 * siehe: estos\etapimonitor\EClientCallInformation.cpp(164)
 */
		if (99999 === arg.data.invokeID && "localBPIInformation" === arg.data.operationName) {
			let oLocalBPIInformationArgument = arg.data.argument;

			// get priority Business-Contact
			const oPriorityInformation = getPriorityBPIInformation(oLocalBPIInformationArgument);
			$("#idType").text(oLocalBPIInformationArgument.EnumJournalCallType);
			$("#idTel").text(oPriorityInformation.telUri);
			$("#idSip").text(oPriorityInformation.sipUri);
			$("#idMailto").text(oPriorityInformation.mailtoUri);
/*
 * Hinweise:
 * Der Host garantiert keine aenderung als Grundlage fuer ein Event.
 * Der Aufruf von requestNewObjectLayout() fuehrt garantiert zu einem onHostMessage().
 * Es ist zu garantieren das man hier keine end-los-schleife verbaut.
 * onHostMessage() -> requestNewObjectLayout() -> und wieder von vorne ...
 */
		}
	} catch (e) {
	}
}

window.addEventListener("load", () => {
	try {
		$("#btnToggle").click(function() {
				$("#idContent").toggle();
				$("#edtBodyScrollHeight").val(document.body.scrollHeight);
/*
 * wir sparen uns explizite snapShot methoden indem wir definieren dass:
 * nach einem requestNewObjectLayout() bzw. OnDocumentCompleted() ein
 * "localBPIInformation" event gefeuert wird!
 * Hinweis:
 * Es ist zu garantieren das man hier keine end-los-schleife verbaut.
 * onHostMessage() -> requestNewObjectLayout() -> und wieder von vorne ...
 */
				requestNewObjectLayout();
		});

/*
* init of: cweapi.js
* - do a one shot trigger of layout with initial size
* - setup event handler to interact with the host
*/
		initCWE(document.body.scrollHeight, myHostMessageHandler);
	} catch(e) {
	}
});
