@echo off
if not exist "%1" goto Usage

del /Q /S %1\*.*

copy "..\MFC_ATL_Client\MFC_ATL_Client.exe - Copy.manifest" %1\MFC_ATL_Client.exe.manifest
copy "..\MFC_ATL_Client\Release\MFC_ATL_Client.exe" %1

rem das manifest fuer die COM-Typen aus der ENetTSC.dll wird vom compiler (ENetTSC.vcproj) erzeugt und
rem   siehe Solution->Properties->Manifest Tool->Isolated COM
rem   mit folgender commandline laesst sich ein korrektes .manifest erzeugen
rem   HINWEIS:
rem     hier fehlen dann aber immer noch die <progid> elemente.
rem     ich denke das assembly .manifest muss letzlich immer von hand geschrieben werden
rem   "C:\Program Files (x86)\Microsoft SDKs\Windows\v7.0A\Bin\mt.exe" /verbose /identity:"ESTOS.ProCall.ENetTSC, version=3.0.0.0" /out:"ESTOS.ProCall.ENetTSC\ESTOS.ProCall.ENetTSC.manifest" /tlb:"..\Win32\ENetTSC.tlb" /dll:"ENetTSC.dll
rem (mit einem CustomBuildStep) unter der resourceid #1 embedded
rem fallstricke:
rem   das vom VS generierte mainfest enthaelt u.a. einen fehlerhaften <trustInfo> knoten
rem   das "einbetten" der .manifest in einem XCOPY deploy halte ich zudem fuer stilbruch

rem mit dieser version erfolgt die SxS configuration durch diskrete files
rem das .manifest fuer das "ESTOS.ProCall.ENetTSC" assembly wurde mit dem "Side-by-Side Manifest Maker" tool von http://www.mazecomputer.com/ erzeugt
rem das "Application" manifest auch
mkdir %1\ESTOS.ProCall.ENetTSC
copy "ESTOS.ProCall.ENetTSC\ESTOS.ProCall.ENetTSC.manifest" %1\ESTOS.ProCall.ENetTSC
copy "..\Win32\Release\ENetTSC.dll" %1\ESTOS.ProCall.ENetTSC

goto exit

:Usage
echo usage:   xcopydeploy ^<destination^>

:exit
